package sound.musica;

import sound.KeyProcessor;
import sound.Scales;
import sound.StochasticControl;
import sound.Utils;

import javax.sound.midi.Synthesizer;
import javax.swing.JFrame;
import javax.swing.JTextArea;
import java.awt.Container;
import java.awt.FlowLayout;


public class Main extends KeyProcessor {
    static class MouseFrame extends JFrame {
        MouseFrame() {
            Container c = getContentPane();

            MusicMouseListener mp
                    = new MusicMouseListener();
            KeyProcessor kp
                    = new KeyProcessor();
            c.addMouseMotionListener(mp);
            c.addMouseListener(mp);
            c.addKeyListener(kp);
            c.setLayout(new FlowLayout());
            final String s =
                    "click here, press"+
            "\nkeys and move mouse";
            c.add(new JTextArea(s));
                        setSize(200, 200);
            setVisible(true);
        }
    }

    public static void main(String args[]) {
        new MouseFrame();
        for (int i = 0; i < 127; i++)
            System.out.println(
                    i + "=" + (char) i);
        StochasticControl.randomNotes(sound.Scales.getScale(
                Scales.HARMONIC_MINOR, 32, 74),
                                      10);
    }


    public static void testNote() {
        int nNoteNumber = 64;	// MIDI key number
        int nVelocity = 127;   //0..127
        int nDuration = 500;   // ms
        Synthesizer synth = Utils.getSynthesizer();
        Utils.play(synth,
                   nNoteNumber,
                   nVelocity,
                   nDuration);
    }

}